"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BlockStatement {
    static visit(node, visitor) {
        for (const stmt of node.body) {
            const result = visitor.visitNode(stmt);
            if (stmt.type === 'ReturnStatement')
                return result;
            if (result === 'break' || result === 'continue')
                return result;
            if ((stmt.type === 'WhileStatement' ||
                stmt.type === 'IfStatement' ||
                stmt.type === 'ForStatement' ||
                stmt.type === 'TryStatement') &&
                !!result) {
                return result;
            }
        }
    }
}
exports.default = BlockStatement;
