"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class FunctionDeclaration {
    static visit(node, visitor) {
        const nameFunction = (name, fn) => Object.defineProperty(fn, 'name', { value: name });
        const { params, body } = node;
        const id = visitor.visitNode(node.id);
        const fn = nameFunction(id, (args) => {
            for (let i = 0; i < params.length; i++) {
                const param_node = visitor.visitNode(params[i]);
                visitor.scope.set(params[i].name, args[i]);
            }
            return visitor.visitNode(body);
        });
        visitor.scope.set(id, fn);
    }
}
exports.default = FunctionDeclaration;
