"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class FunctionExpression {
    static visit(node, visitor) {
        const nameFunction = (name, fn) => Object.defineProperty(fn, 'name', { value: name });
        const { params, body } = node;
        const fn = nameFunction('anonymous function', (args) => {
            for (let i = 0; i < params.length; i++) {
                const param_node = visitor.visitNode(params[i]);
                visitor.scope.set(params[i].name, args[i]);
            }
            return visitor.visitNode(body);
        });
        return fn;
    }
}
exports.default = FunctionExpression;
