"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LogicalExpression {
    static visit(node, visitor) {
        const operator = node.operator;
        switch (operator) {
            case '&&': {
                const left_side = visitor.visitNode(node.left);
                if (left_side === true)
                    return visitor.visitNode(node.right);
                return left_side;
            }
            case '||': {
                const left_side = visitor.visitNode(node.left);
                return left_side || visitor.visitNode(node.right);
            }
            default:
                throw Error(`Unsupported logical operator: ${operator}`);
        }
    }
}
exports.default = LogicalExpression;
