"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class TryStatement {
    static visit(node, visitor) {
        try {
            return visitor.visitNode(node.block);
        }
        catch (e) {
            visitor.scope.set(node.handler.param.name, e);
            return visitor.visitNode(node.handler.body);
        }
        finally {
            visitor.visitNode(node.finalizer);
        }
    }
}
exports.default = TryStatement;
