"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class UnaryExpression {
    static visit(node, visitor) {
        const operator = node.operator;
        switch (operator) {
            case '-': {
                const arg = visitor.visitNode(node.argument);
                return -arg;
            }
            case 'void': {
                visitor.visitNode(node.argument);
                return undefined;
            }
            default:
                console.warn('Unsupported operator: ', operator);
        }
    }
}
exports.default = UnaryExpression;
