export default class Visitor {
    scope: Map<string, any>;
    listeners: {
        [key: string]: Function;
    };
    ast: any[];
    constructor(ast: any[]);
    /**
     * Starts interpreting the program.
     */
    run(): any;
    /**
     * Visits given node and executes it.
     */
    visitNode(node: any): any;
    /**
     * Listens for node calls. Can be used to implement new functionality.
     * @param node_name - the node to listen for.
     * @param fn - the callback function.
     */
    on(node_name: string, fn: Function): void;
}
